import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'car' },
})
export class Car extends BaseModel {
  @prop({ required: false, index: false, zh: '店铺id' })
  shop: string;
  @prop({ required: false, index: false, zh: '车辆识别VIN' })
  vin: string;
  @prop({ required: false, index: false, zh: '首次上牌时间' })
  f_time: string;
  @prop({ required: false, index: false, zh: '车源地', remark: '字典.行政区划' })
  place: string;
  @prop({ required: false, index: false, zh: '车牌地', remark: '字典.行政区划' })
  license: string;
  @prop({ required: false, index: false, zh: '外观颜色' })
  out_color: string;
  @prop({ required: false, index: false, zh: '内饰颜色' })
  in_color: string;
  @prop({ required: false, index: false, zh: '车辆使用性质', remark: '字典:车辆使用性质' })
  use_type: string;
  @prop({ required: false, index: false, zh: '价格', remark: '万元' })
  price: number;
  @prop({ required: false, index: false, zh: '车龄' })
  age: number;
  @prop({ required: false, index: false, zh: '里程', remark: '万公里' })
  mileage: number;
  @prop({ required: false, index: false, zh: '变速箱', remark: '字典:变速箱类型' })
  type: string;
  @prop({ required: false, index: false, zh: '车身结构', remark: '字典:车身结构' })
  structure: string;
  @prop({ required: false, index: false, zh: '排放标准', remark: '字典:排放标准' })
  emission: string;
  @prop({ required: false, index: false, zh: '能源类型', remark: '字典:能源类型' })
  energy: string;
  @prop({ required: false, index: false, zh: '排量', remark: '字典:排量' })
  displacement: string;
  @prop({ required: false, index: false, zh: '座椅', remark: '字典:座椅' })
  set: string;
  @prop({ required: false, index: false, zh: '车辆级别', remark: '字典:车辆级别' })
  level: string;
  @prop({ required: false, index: false, zh: '驱动方式', remark: '字典:驱动方式' })
  drive: string;
  @prop({ required: false, index: false, zh: '油耗', remark: '用车成本:单位:L' })
  oil: string;
  @prop({ required: false, index: false, zh: '年均保险费', remark: '用车成本:单位:元' })
  premium: string;
  @prop({ required: false, index: false, zh: '年均保养费', remark: '用车成本:' })
  maintenance: string;
  @prop({ required: false, index: false, zh: '百公里加速', remark: '单位:s' })
  hundred_time: string;
  @prop({ required: false, index: false, zh: '轴距', remark: '单位:mm' })
  wheelbase: string;
  @prop({ required: false, index: false, zh: '总价' })
  total_money: string;
  @prop({ required: false, index: false, zh: '付款方式', remark: '字典:付款方式' })
  pay_type: string;
  @prop({ required: false, index: false, zh: '首付' })
  first_pay: string;
  @prop({ required: false, index: false, zh: '实付价格' })
  real_pay: string;
  @prop({ required: false, index: false, zh: '品牌', remark: '合成标题用:1' })
  brand: string;
  @prop({ required: false, index: false, zh: '车型', remark: '合成标题用:2' })
  series: string;
  @prop({ required: false, index: false, zh: '年份', remark: '合成标题用:3' })
  year: string;
  @prop({ required: false, index: false, zh: '车款', remark: '合成标题用:4' })
  style: string;
  @prop({ required: false, index: false, zh: '过户次数' })
  number: string;
  @prop({ required: false, index: false, zh: '车辆图片' })
  file: Array<any>;
  @prop({ required: false, index: false, zh: '状态', remark: '字典:车源状态', default: '0' })
  status: string;
}
