import { modelOptions, prop } from '@typegoose/typegoose';
import { BaseModel } from 'free-midway-component';
@modelOptions({
  schemaOptions: { collection: 'estimate' },
})
export class Estimate extends BaseModel {
  @prop({ required: false, index: false, zh: '微信用户' })
  openid: string;
  @prop({ required: false, index: false, zh: '品牌' })
  brand: string;
  @prop({ required: false, index: false, zh: '车型' })
  type: string;
  @prop({ required: false, index: false, zh: '车系' })
  bank: string;
  @prop({ required: false, index: false, zh: '上牌日期' })
  start: string;
  @prop({ required: false, index: false, zh: '行驶里程' })
  course: string;
  @prop({ required: false, index: false, zh: '上牌城市' })
  city: string;
  @prop({ required: false, index: false, zh: '所在地区' })
  place: string;
  @prop({ required: false, index: false, zh: '联系人' })
  contacts: string;
  @prop({ required: false, index: false, zh: '联系电话' })
  tel: string;
  @prop({ required: false, index: false, zh: '预估金额', remark: '单位:万元' })
  estimate: string;
  @prop({ required: false, index: false, zh: '状态', default: '0' })
  status: string;
}
