import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_car {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '店铺' })
  'shop': string = undefined;
  @ApiProperty({ description: '车辆识别VIN' })
  'vin': string = undefined;
  @ApiProperty({ description: '首次上牌时间' })
  'f_time': string = undefined;
  @ApiProperty({ description: '车源地' })
  'place': string = undefined;
  @ApiProperty({ description: '车牌地' })
  'license': string = undefined;
  @ApiProperty({ description: '外观颜色' })
  'out_color': string = undefined;
  @ApiProperty({ description: '内饰颜色' })
  'in_color': string = undefined;
  @ApiProperty({ description: '车辆使用性质' })
  'use_type': string = undefined;
  @ApiProperty({ description: '价格' })
  'price': number = undefined;
  @ApiProperty({ description: '车龄' })
  'age': number = undefined;
  @ApiProperty({ description: '里程' })
  'mileage': number = undefined;
  @ApiProperty({ description: '变速箱' })
  'type': string = undefined;
  @ApiProperty({ description: '车身结构' })
  'structure': string = undefined;
  @ApiProperty({ description: '排放标准' })
  'emission': string = undefined;
  @ApiProperty({ description: '能源类型' })
  'energy': string = undefined;
  @ApiProperty({ description: '排量' })
  'displacement': string = undefined;
  @ApiProperty({ description: '座椅' })
  'set': string = undefined;
  @ApiProperty({ description: '车辆级别' })
  'level': string = undefined;
  @ApiProperty({ description: '驱动方式' })
  'drive': string = undefined;
  @ApiProperty({ description: '油耗' })
  'oil': string = undefined;
  @ApiProperty({ description: '年均保险费' })
  'premium': string = undefined;
  @ApiProperty({ description: '年均保养费' })
  'maintenance': string = undefined;
  @ApiProperty({ description: '百公里加速' })
  'hundred_time': string = undefined;
  @ApiProperty({ description: '轴距' })
  'wheelbase': string = undefined;
  @ApiProperty({ description: '总价' })
  'total_money': string = undefined;
  @ApiProperty({ description: '付款方式' })
  'pay_type': string = undefined;
  @ApiProperty({ description: '首付' })
  'first_pay': string = undefined;
  @ApiProperty({ description: '实付价格' })
  'real_pay': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
  @ApiProperty({ description: '品牌' })
  'brand': string = undefined;
  @ApiProperty({ description: '车型' })
  'series': string = undefined;
  @ApiProperty({ description: '年份' })
  'year': string = undefined;
  @ApiProperty({ description: '车款' })
  'style': string = undefined;
  @ApiProperty({ description: '过户次数' })
  'number': string = undefined;
  @ApiProperty({ description: '车辆图片' })
  'file': Array<any> = undefined;
}

export class QDTO_car extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['shop', 'brand', 'place', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_car extends FVO_car {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_car {
  @ApiProperty({ description: '店铺' })
  @Rule(RuleType['string']().empty(''))
  'shop': string = undefined;
  @ApiProperty({ description: '车辆识别VIN' })
  @Rule(RuleType['string']().empty(''))
  'vin': string = undefined;
  @ApiProperty({ description: '首次上牌时间' })
  @Rule(RuleType['string']().empty(''))
  'f_time': string = undefined;
  @ApiProperty({ description: '车源地' })
  @Rule(RuleType['string']().empty(''))
  'place': string = undefined;
  @ApiProperty({ description: '车牌地' })
  @Rule(RuleType['string']().empty(''))
  'license': string = undefined;
  @ApiProperty({ description: '外观颜色' })
  @Rule(RuleType['string']().empty(''))
  'out_color': string = undefined;
  @ApiProperty({ description: '内饰颜色' })
  @Rule(RuleType['string']().empty(''))
  'in_color': string = undefined;
  @ApiProperty({ description: '车辆使用性质' })
  @Rule(RuleType['string']().empty(''))
  'use_type': string = undefined;
  @ApiProperty({ description: '价格' })
  @Rule(RuleType['number']().empty(''))
  'price': number = undefined;
  @ApiProperty({ description: '车龄' })
  @Rule(RuleType['number']().empty(''))
  'age': number = undefined;
  @ApiProperty({ description: '里程' })
  @Rule(RuleType['number']().empty(''))
  'mileage': number = undefined;
  @ApiProperty({ description: '变速箱' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '车身结构' })
  @Rule(RuleType['string']().empty(''))
  'structure': string = undefined;
  @ApiProperty({ description: '排放标准' })
  @Rule(RuleType['string']().empty(''))
  'emission': string = undefined;
  @ApiProperty({ description: '能源类型' })
  @Rule(RuleType['string']().empty(''))
  'energy': string = undefined;
  @ApiProperty({ description: '排量' })
  @Rule(RuleType['string']().empty(''))
  'displacement': string = undefined;
  @ApiProperty({ description: '座椅' })
  @Rule(RuleType['string']().empty(''))
  'set': string = undefined;
  @ApiProperty({ description: '车辆级别' })
  @Rule(RuleType['string']().empty(''))
  'level': string = undefined;
  @ApiProperty({ description: '驱动方式' })
  @Rule(RuleType['string']().empty(''))
  'drive': string = undefined;
  @ApiProperty({ description: '油耗' })
  @Rule(RuleType['string']().empty(''))
  'oil': string = undefined;
  @ApiProperty({ description: '年均保险费' })
  @Rule(RuleType['string']().empty(''))
  'premium': string = undefined;
  @ApiProperty({ description: '年均保养费' })
  @Rule(RuleType['string']().empty(''))
  'maintenance': string = undefined;
  @ApiProperty({ description: '百公里加速' })
  @Rule(RuleType['string']().empty(''))
  'hundred_time': string = undefined;
  @ApiProperty({ description: '轴距' })
  @Rule(RuleType['string']().empty(''))
  'wheelbase': string = undefined;
  @ApiProperty({ description: '总价' })
  @Rule(RuleType['string']().empty(''))
  'total_money': string = undefined;
  @ApiProperty({ description: '付款方式' })
  @Rule(RuleType['string']().empty(''))
  'pay_type': string = undefined;
  @ApiProperty({ description: '首付' })
  @Rule(RuleType['string']().empty(''))
  'first_pay': string = undefined;
  @ApiProperty({ description: '实付价格' })
  @Rule(RuleType['string']().empty(''))
  'real_pay': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
  @ApiProperty({ description: '品牌' })
  @Rule(RuleType['string']().empty(''))
  'brand': string = undefined;
  @ApiProperty({ description: '车型' })
  @Rule(RuleType['string']().empty(''))
  'series': string = undefined;
  @ApiProperty({ description: '年份' })
  @Rule(RuleType['string']().empty(''))
  'year': string = undefined;
  @ApiProperty({ description: '车款' })
  @Rule(RuleType['string']().empty(''))
  'style': string = undefined;
  @ApiProperty({ description: '过户次数' })
  @Rule(RuleType['string']().empty(''))
  'number': string = undefined;
  @ApiProperty({ description: '车辆图片' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
}

export class CVO_car extends FVO_car {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_car extends CDTO_car {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_car extends FVO_car {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
