import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_config {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '销售模式' })
  'mode': string = undefined;
  @ApiProperty({ description: '平台名称' })
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '联系人' })
  'contacts': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'tel': string = undefined;
  @ApiProperty({ description: '用户协议' })
  'agreement': string = undefined;
  @ApiProperty({ description: '底部文案' })
  'bottom_title': string = undefined;
}

export class QDTO_config extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_config {
  @ApiProperty({ description: '销售模式' })
  @Rule(RuleType['string']().empty(''))
  'mode': string = undefined;
  @ApiProperty({ description: '平台名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contacts': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'tel': string = undefined;
  @ApiProperty({ description: '用户协议' })
  @Rule(RuleType['string']().empty(''))
  'agreement': string = undefined;
  @ApiProperty({ description: '底部文案' })
  @Rule(RuleType['string']().empty(''))
  'bottom_title': string = undefined;
}

export class CVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_config extends CDTO_config {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
