import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_estimate {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '微信用户' })
  'openid': string = undefined;
  @ApiProperty({ description: '品牌' })
  'brand': string = undefined;
  @ApiProperty({ description: '车型' })
  'type': string = undefined;
  @ApiProperty({ description: '车系' })
  'bank': string = undefined;
  @ApiProperty({ description: '上牌日期' })
  'start': string = undefined;
  @ApiProperty({ description: '行驶里程' })
  'course': string = undefined;
  @ApiProperty({ description: '上牌城市' })
  'city': string = undefined;
  @ApiProperty({ description: '所在地区' })
  'place': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contacts': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'tel': string = undefined;
  @ApiProperty({ description: '预估金额' })
  'estimate': string = undefined;
  @ApiProperty({ description: '状态' })
  'status': string = undefined;
}

export class QDTO_estimate extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['contacts', 'brand', 'tel', 'status'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_estimate extends FVO_estimate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_estimate {
  @ApiProperty({ description: '微信用户' })
  @Rule(RuleType['string']().empty(''))
  'openid': string = undefined;
  @ApiProperty({ description: '品牌' })
  @Rule(RuleType['string']().empty(''))
  'brand': string = undefined;
  @ApiProperty({ description: '车型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '车系' })
  @Rule(RuleType['string']().empty(''))
  'bank': string = undefined;
  @ApiProperty({ description: '上牌日期' })
  @Rule(RuleType['string']().empty(''))
  'start': string = undefined;
  @ApiProperty({ description: '行驶里程' })
  @Rule(RuleType['string']().empty(''))
  'course': string = undefined;
  @ApiProperty({ description: '上牌城市' })
  @Rule(RuleType['string']().empty(''))
  'city': string = undefined;
  @ApiProperty({ description: '所在地区' })
  @Rule(RuleType['string']().empty(''))
  'place': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contacts': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'tel': string = undefined;
  @ApiProperty({ description: '预估金额' })
  @Rule(RuleType['string']().empty(''))
  'estimate': string = undefined;
  @ApiProperty({ description: '状态' })
  @Rule(RuleType['string']().empty(''))
  'status': string = undefined;
}

export class CVO_estimate extends FVO_estimate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_estimate extends CDTO_estimate {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_estimate extends FVO_estimate {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
