import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_shop {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '店铺名称' })
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '店铺地址' })
  'address': string = undefined;
  @ApiProperty({ description: '联系电话' })
  'tel': string = undefined;
  @ApiProperty({ description: '联系人' })
  'contacts': string = undefined;
  @ApiProperty({ description: '营业执照' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_shop extends SearchBase {
  constructor() {
    const like_prop = ['name', 'contacts'];
    const props = ['is_use', 'tel'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_shop extends FVO_shop {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_shop {
  @ApiProperty({ description: '店铺名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '店铺地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'tel': string = undefined;
  @ApiProperty({ description: '联系人' })
  @Rule(RuleType['string']().empty(''))
  'contacts': string = undefined;
  @ApiProperty({ description: '营业执照' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_shop extends FVO_shop {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_shop extends CDTO_shop {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_shop extends FVO_shop {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
