import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_brand {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '品牌名' })
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '首字母' })
  'letter': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_brand extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['letter', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_brand extends FVO_brand {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_brand {
  @ApiProperty({ description: '品牌名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: 'logo' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '首字母' })
  @Rule(RuleType['string']().empty(''))
  'letter': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_brand extends FVO_brand {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_brand extends CDTO_brand {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_brand extends FVO_brand {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
