import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_follow {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '用户id' })
  'user': string = undefined;
  @ApiProperty({ description: '车源数据' })
  'car': string = undefined;
}


export class QDTO_follow extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}


export class QVO_follow extends FVO_follow {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class CDTO_follow {
  @ApiProperty({ description: '用户id' })
@Rule(RuleType['string']().empty(''))
  'user': string = undefined;
  @ApiProperty({ description: '车源数据' })
@Rule(RuleType['string']().empty(''))
  'car': string = undefined;
}


export class CVO_follow extends FVO_follow {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}


export class UDTO_follow extends CDTO_follow {
    @ApiProperty({ description: '数据id' })
    @Rule(RuleType['string']().empty(''))
    _id: string = undefined;
}


export class UVAO_follow extends FVO_follow {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}