import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { Brand } from '../../entity/system/brand.entity';
type modelType = ReturnModelType<typeof Brand>;
@Provide()
export class BrandService extends BaseService<modelType> {
  @InjectEntityModel(Brand)
  model: modelType;

  async queryIndex() {
    const list = await this.model.aggregate([{ $match: { is_use: '0' } }, { $sort: { letter: 1 } }, { $group: { _id: '$letter', data: { $addToSet: '$$ROOT' } } }]);
    const data1 = [];
    const data2 = [];
    for (const val of list) {
      data1.push(val.data);
      data2.push(val._id);
    }
    return { data1, data2 };
  }
}
