import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService, FrameworkErrorEnum, ServiceError } from 'free-midway-component';
import { Admin } from '../../entity/user/admin.entity';
type modelType = ReturnModelType<typeof Admin>;
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
import get = require('lodash/get');
@Provide()
export class AdminService extends BaseService<modelType> {
  @InjectEntityModel(Admin)
  model: modelType;

  async initSuper() {
    const data = {
      account: 'admin',
      password: '1qaz2wsx',
      nick_name: '系统管理员',
      is_super: '0',
      is_platform: '0',
    };
    const is_exist = await this.model.count({ is_super: '0' });
    if (!is_exist) await this.model.create(data);
    return;
  }

  async checkIsExist(data) {
    if (!get(data, 'account')) return true;
    const checkData: any = { account: get(data, 'account'), shop: get(data, 'account') };
    if (get(data, '_id')) checkData._id = { $ne: new ObjectId(get(data, '_id')) };
    const num = await this.model.count(checkData);
    if (num > 0) throw new ServiceError('账户已存在!', FrameworkErrorEnum.SERVICE_FAULT);
    return true;
  }
}
