import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService, FrameworkErrorEnum, ServiceError } from 'free-midway-component';
import { User } from '../../entity/user/user.entity';
type modelType = ReturnModelType<typeof User>;
import get = require('lodash/get');
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
@Provide()
export class UserService extends BaseService<modelType> {
  @InjectEntityModel(User)
  model: modelType;

  async checkIsExist(data) {
    if (!get(data, 'openid')) return true;
    const checkData: any = { openid: get(data, 'openid'), shop: get(data, 'shop') };
    if (get(data, '_id')) checkData._id = { $ne: new ObjectId(get(data, '_id')) };
    const num = await this.model.count(checkData);
    if (num > 0) throw new ServiceError('账户已存在!', FrameworkErrorEnum.SERVICE_FAULT);
    return true;
  }
}
